Index: c/src/librdbg/src/i386/any/Makefile.in
===================================================================
--- c/src/librdbg/src/i386/any/Makefile.in	(revision 116e54ad1670c240773e5a9a0193dd736de8a934)
+++ 	(revision )
@@ -1,316 +1,0 @@
-# Makefile.in generated automatically by automake 1.4a from Makefile.am
-
-# Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
-# This Makefile.in is free software; the Free Software Foundation
-# gives unlimited permission to copy and/or distribute it,
-# with or without modifications, as long as this notice is preserved.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
-# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
-# PARTICULAR PURPOSE.
-
-
-
-
-SHELL = @SHELL@
-
-srcdir = @srcdir@
-top_srcdir = @top_srcdir@
-prefix = @prefix@
-exec_prefix = @exec_prefix@
-
-bindir = @bindir@
-sbindir = @sbindir@
-libexecdir = @libexecdir@
-datadir = @datadir@
-sysconfdir = @sysconfdir@
-sharedstatedir = @sharedstatedir@
-localstatedir = @localstatedir@
-libdir = @libdir@
-infodir = @infodir@
-mandir = @mandir@
-includedir = @includedir@
-oldincludedir = /usr/include
-
-DESTDIR =
-
-pkgdatadir = $(datadir)/@PACKAGE@
-pkglibdir = $(libdir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
-
-top_builddir = ../../..
-
-ACLOCAL = @ACLOCAL@
-AUTOCONF = @AUTOCONF@
-AUTOMAKE = @AUTOMAKE@
-AUTOHEADER = @AUTOHEADER@
-
-INSTALL = @INSTALL@
-INSTALL_PROGRAM = @INSTALL_PROGRAM@
-INSTALL_DATA = @INSTALL_DATA@
-INSTALL_SCRIPT = @INSTALL_SCRIPT@
-INSTALL_STRIP_FLAG =
-transform = @program_transform_name@
-
-NORMAL_INSTALL = :
-PRE_INSTALL = :
-POST_INSTALL = :
-NORMAL_UNINSTALL = :
-PRE_UNINSTALL = :
-POST_UNINSTALL = :
-build_alias = @build_alias@
-build_triplet = @build@
-host_alias = @host_alias@
-host_triplet = @host@
-target_alias = @target_alias@
-target_triplet = @target@
-CC = @CC@
-CC_FOR_TARGET = @CC_FOR_TARGET@
-CPP = @CPP@
-GCCSED = @GCCSED@
-HAS_NETWORKING = @HAS_NETWORKING@
-HAS_RDBG = @HAS_RDBG@
-INSTALL_CHANGE = @INSTALL_CHANGE@
-MAINT = @MAINT@
-MAKEINFO = @MAKEINFO@
-PACKAGE = @PACKAGE@
-PACKHEX = @PACKHEX@
-PROJECT_INCLUDE = @PROJECT_INCLUDE@
-PROJECT_ROOT = @PROJECT_ROOT@
-RTEMS_BSP = @RTEMS_BSP@
-RTEMS_CPU = @RTEMS_CPU@
-RTEMS_HAS_NETWORKING = @RTEMS_HAS_NETWORKING@
-RTEMS_HAS_RDBG = @RTEMS_HAS_RDBG@
-RTEMS_HOST = @RTEMS_HOST@
-RTEMS_LIBC_DIR = @RTEMS_LIBC_DIR@
-RTEMS_ROOT = @RTEMS_ROOT@
-RTEMS_TOPdir = @RTEMS_TOPdir@
-VERSION = @VERSION@
-
-AUTOMAKE_OPTIONS = foreign 1.4
-
-VPATH = @srcdir@:@srcdir@/..:@srcdir@/../..
-
-LIBNAME = librdbg
-LIB = ${ARCH}/${LIBNAME}.a
-
-# C and C++ source names, if any, go here -- minus the .c or .cc
-C_FILES = rdbg.c servcon.c servbkpt.c servrpc.c excep.c excep_f.c servtgt.c     servtsp.c servutil.c _servtgt.c rdbg_f.c ptrace.c
-
-C_O_FILES = $(C_FILES:%.c=${ARCH}/%.o)
-
-# Asm source names, if any, go here -- minus the .s 
-S_FILES = rdbg_cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=${ARCH}/%.o)
-
-# Generated C source names, if any, go here -- minus the .c
-GEN_C_FILES = remdeb_xdr.c remdeb_svc.c
-GEN_C_O_FILES = $(GEN_C_PIECES:%.c=${ARCH}/%.o)
-
-# H source names, if any, go here -- minus the .h
-H_FILES = remdeb.h
-
-# X source names
-X_FILES = remdeb.x remdeb_f.x
-
-SRCS = $(C_FILES) $(S_FILES) $(GEN_C_FILES) $(H_FILES)
-OBJS = $(GEN_C_O_FILES) $(C_O_FILES) $(S_O_FILES)
-
-RPCGEN = @RPCGEN@
-AWK = @AWK@
-
-TMPINSTALL_FILES = $(PROJECT_RELEASE)/lib $(PROJECT_RELEASE)/lib/$(LIBNAME)$(LIBVARIANT).a
-
-
-PREINSTALL_FILES =  $(PROJECT_INCLUDE)/rdbg $(PROJECT_INCLUDE)/rdbg/remdeb.h
-
-
-#
-# Add local stuff here using +=
-#
-
-#
-# Add your list of files to delete here.  The config files
-#  already know how to delete some stuff, so you may want
-#  to just run 'make clean' first to see what gets missed.
-#  'make clobber' already includes 'make clean'
-#
-
-CLEANFILES =  $(LIB) $(H_FILES) $(GEN_C_FILES)
-
-FRONTEND = \"$(RTEMS_CPU)/@RTEMS_BSP@/remdeb_f.x\"
-
-EXTRA_DIST = remdeb_f.x
-mkinstalldirs = $(SHELL) $(top_srcdir)/../../../mkinstalldirs
-CONFIG_CLEAN_FILES = 
-DIST_COMMON =  Makefile.am Makefile.in
-
-
-DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
-
-TAR = gtar
-GZIP_ENV = --best
-all: all-redirect
-.SUFFIXES:
-$(srcdir)/Makefile.in: @MAINTAINER_MODE_TRUE@ Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) $(top_srcdir)/../../../automake/lib.am $(top_srcdir)/../../../automake/local.am
-	cd $(top_srcdir) && $(AUTOMAKE) --foreign src/i386/pc386/Makefile
-
-Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status $(BUILT_SOURCES)
-	cd $(top_builddir) \
-	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
-
-tags: TAGS
-TAGS:
-
-
-distdir = $(top_builddir)/$(PACKAGE)-$(VERSION)/$(subdir)
-
-subdir = src/i386/pc386
-
-distdir: $(DISTFILES)
-	here=`cd $(top_builddir) && pwd`; \
-	top_distdir=`cd $(top_distdir) && pwd`; \
-	distdir=`cd $(distdir) && pwd`; \
-	cd $(top_srcdir) \
-	  && $(AUTOMAKE) --include-deps --build-dir=$$here --srcdir-name=$(top_srcdir) --output-dir=$$top_distdir --foreign src/i386/pc386/Makefile
-	@for file in $(DISTFILES); do \
-	  d=$(srcdir); \
-	  if test -d $$d/$$file; then \
-	    cp -pr $$d/$$file $(distdir)/$$file; \
-	  else \
-	    test -f $(distdir)/$$file \
-	    || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
-	    || cp -p $$d/$$file $(distdir)/$$file || :; \
-	  fi; \
-	done
-info-am:
-info: info-am
-dvi-am:
-dvi: dvi-am
-check-am: all-am
-check: check-am
-installcheck-am:
-installcheck: installcheck-am
-install-exec-am:
-install-exec: install-exec-am
-
-install-data-am:
-install-data: install-data-am
-
-install-am: all-am
-	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
-install: install-am
-uninstall-am:
-uninstall: uninstall-am
-all-am: Makefile
-all-redirect: all-am
-install-strip:
-	$(MAKE) $(AM_MAKEFLAGS) INSTALL_STRIP_FLAG=-s install
-installdirs:
-
-
-mostlyclean-generic:
-
-clean-generic:
-	-test -z "$(CLEANFILES)" || rm -f $(CLEANFILES)
-
-distclean-generic:
-	-rm -f Makefile $(CONFIG_CLEAN_FILES)
-	-rm -f config.cache config.log stamp-h stamp-h[0-9]*
-
-maintainer-clean-generic:
-mostlyclean-am:  mostlyclean-generic
-
-mostlyclean: mostlyclean-am
-
-clean-am:  clean-generic mostlyclean-am
-
-clean: clean-am
-
-distclean-am:  distclean-generic clean-am
-
-distclean: distclean-am
-
-maintainer-clean-am:  maintainer-clean-generic distclean-am
-	@echo "This command is intended for maintainers to use;"
-	@echo "it deletes files that may require special tools to rebuild."
-
-maintainer-clean: maintainer-clean-am
-
-.PHONY: tags distdir info-am info dvi-am dvi check check-am \
-installcheck-am installcheck install-exec-am install-exec \
-install-data-am install-data install-am install uninstall-am uninstall \
-all-redirect all-am all installdirs mostlyclean-generic \
-distclean-generic clean-generic maintainer-clean-generic clean \
-mostlyclean distclean maintainer-clean
-
-
-include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-
-include $(RTEMS_ROOT)/make/leaf.cfg
-
-define make-library
-$(RM) $@
-$(AR) $(ARFLAGS) $@ $^
-$(RANLIB) $@
-endef
-
-$(PROJECT_INCLUDE)/lib:
-	@$(mkinstalldirs) $@
-
-.PRECIOUS: $(LIB)
-
-$(PROJECT_INCLUDE)/rdbg:
-	@$(mkinstalldirs) $@
-
-$(PROJECT_RELEASE)/lib/$(LIBNAME)$(LIBVARIANT).a: $(LIB)
-	$(INSTALL_DATA) $< $@
-
-all: ${ARCH} $(PREINSTALL_FILES) $(TMPINSTALL_FILES)
-
-$(LIB): ${OBJS}
-	$(make-library)
-
-remdeb.h: $(X_FILES)
-	@rm -f $@
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -h -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/$@ remdeb.x )
-
-$(PROJECT_INCLUDE)/rdbg/remdeb.h: remdeb.h
-	$(INSTALL_DATA) $< $@
-
-remdeb_xdr.c: $(X_FILES)
-	@rm -f $@
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -c -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/$@ remdeb.x )
-
-remdeb_svc.c: $(X_FILES)
-	@rm -f $@ tmpSvc.c
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -s udp -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/tmpSvc.c remdeb.x )
-	$(AWK) -f $(srcdir)/../../awk.svc THEPROG="remdeb.h" tmpSvc.c >$@
-	@rm -f tmpSvc.c
-
-debug-am:
-debug: debug-am
-.PHONY: debug debug-am
-
-profile-am:
-profile: profile-am
-.PHONY: profile profile-am
-
-preinstall-am: $(PREINSTALL_FILES)
-preinstall: preinstall-am
-.PHONY: preinstall preinstall-am
-
-depend-am:
-depend: depend-am
-.PHONY: depend depend-am
-
-# Tell versions [3.59,3.63) of GNU make to not export all variables.
-# Otherwise a system limit (for SysV at least) may be exceeded.
-.NOEXPORT:
Index: c/src/librdbg/src/i386/pc386/Makefile.in
===================================================================
--- c/src/librdbg/src/i386/pc386/Makefile.in	(revision 116e54ad1670c240773e5a9a0193dd736de8a934)
+++ 	(revision )
@@ -1,316 +1,0 @@
-# Makefile.in generated automatically by automake 1.4a from Makefile.am
-
-# Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
-# This Makefile.in is free software; the Free Software Foundation
-# gives unlimited permission to copy and/or distribute it,
-# with or without modifications, as long as this notice is preserved.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
-# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
-# PARTICULAR PURPOSE.
-
-
-
-
-SHELL = @SHELL@
-
-srcdir = @srcdir@
-top_srcdir = @top_srcdir@
-prefix = @prefix@
-exec_prefix = @exec_prefix@
-
-bindir = @bindir@
-sbindir = @sbindir@
-libexecdir = @libexecdir@
-datadir = @datadir@
-sysconfdir = @sysconfdir@
-sharedstatedir = @sharedstatedir@
-localstatedir = @localstatedir@
-libdir = @libdir@
-infodir = @infodir@
-mandir = @mandir@
-includedir = @includedir@
-oldincludedir = /usr/include
-
-DESTDIR =
-
-pkgdatadir = $(datadir)/@PACKAGE@
-pkglibdir = $(libdir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
-
-top_builddir = ../../..
-
-ACLOCAL = @ACLOCAL@
-AUTOCONF = @AUTOCONF@
-AUTOMAKE = @AUTOMAKE@
-AUTOHEADER = @AUTOHEADER@
-
-INSTALL = @INSTALL@
-INSTALL_PROGRAM = @INSTALL_PROGRAM@
-INSTALL_DATA = @INSTALL_DATA@
-INSTALL_SCRIPT = @INSTALL_SCRIPT@
-INSTALL_STRIP_FLAG =
-transform = @program_transform_name@
-
-NORMAL_INSTALL = :
-PRE_INSTALL = :
-POST_INSTALL = :
-NORMAL_UNINSTALL = :
-PRE_UNINSTALL = :
-POST_UNINSTALL = :
-build_alias = @build_alias@
-build_triplet = @build@
-host_alias = @host_alias@
-host_triplet = @host@
-target_alias = @target_alias@
-target_triplet = @target@
-CC = @CC@
-CC_FOR_TARGET = @CC_FOR_TARGET@
-CPP = @CPP@
-GCCSED = @GCCSED@
-HAS_NETWORKING = @HAS_NETWORKING@
-HAS_RDBG = @HAS_RDBG@
-INSTALL_CHANGE = @INSTALL_CHANGE@
-MAINT = @MAINT@
-MAKEINFO = @MAKEINFO@
-PACKAGE = @PACKAGE@
-PACKHEX = @PACKHEX@
-PROJECT_INCLUDE = @PROJECT_INCLUDE@
-PROJECT_ROOT = @PROJECT_ROOT@
-RTEMS_BSP = @RTEMS_BSP@
-RTEMS_CPU = @RTEMS_CPU@
-RTEMS_HAS_NETWORKING = @RTEMS_HAS_NETWORKING@
-RTEMS_HAS_RDBG = @RTEMS_HAS_RDBG@
-RTEMS_HOST = @RTEMS_HOST@
-RTEMS_LIBC_DIR = @RTEMS_LIBC_DIR@
-RTEMS_ROOT = @RTEMS_ROOT@
-RTEMS_TOPdir = @RTEMS_TOPdir@
-VERSION = @VERSION@
-
-AUTOMAKE_OPTIONS = foreign 1.4
-
-VPATH = @srcdir@:@srcdir@/..:@srcdir@/../..
-
-LIBNAME = librdbg
-LIB = ${ARCH}/${LIBNAME}.a
-
-# C and C++ source names, if any, go here -- minus the .c or .cc
-C_FILES = rdbg.c servcon.c servbkpt.c servrpc.c excep.c excep_f.c servtgt.c     servtsp.c servutil.c _servtgt.c rdbg_f.c ptrace.c
-
-C_O_FILES = $(C_FILES:%.c=${ARCH}/%.o)
-
-# Asm source names, if any, go here -- minus the .s 
-S_FILES = rdbg_cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=${ARCH}/%.o)
-
-# Generated C source names, if any, go here -- minus the .c
-GEN_C_FILES = remdeb_xdr.c remdeb_svc.c
-GEN_C_O_FILES = $(GEN_C_PIECES:%.c=${ARCH}/%.o)
-
-# H source names, if any, go here -- minus the .h
-H_FILES = remdeb.h
-
-# X source names
-X_FILES = remdeb.x remdeb_f.x
-
-SRCS = $(C_FILES) $(S_FILES) $(GEN_C_FILES) $(H_FILES)
-OBJS = $(GEN_C_O_FILES) $(C_O_FILES) $(S_O_FILES)
-
-RPCGEN = @RPCGEN@
-AWK = @AWK@
-
-TMPINSTALL_FILES = $(PROJECT_RELEASE)/lib $(PROJECT_RELEASE)/lib/$(LIBNAME)$(LIBVARIANT).a
-
-
-PREINSTALL_FILES =  $(PROJECT_INCLUDE)/rdbg $(PROJECT_INCLUDE)/rdbg/remdeb.h
-
-
-#
-# Add local stuff here using +=
-#
-
-#
-# Add your list of files to delete here.  The config files
-#  already know how to delete some stuff, so you may want
-#  to just run 'make clean' first to see what gets missed.
-#  'make clobber' already includes 'make clean'
-#
-
-CLEANFILES =  $(LIB) $(H_FILES) $(GEN_C_FILES)
-
-FRONTEND = \"$(RTEMS_CPU)/@RTEMS_BSP@/remdeb_f.x\"
-
-EXTRA_DIST = remdeb_f.x
-mkinstalldirs = $(SHELL) $(top_srcdir)/../../../mkinstalldirs
-CONFIG_CLEAN_FILES = 
-DIST_COMMON =  Makefile.am Makefile.in
-
-
-DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
-
-TAR = gtar
-GZIP_ENV = --best
-all: all-redirect
-.SUFFIXES:
-$(srcdir)/Makefile.in: @MAINTAINER_MODE_TRUE@ Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) $(top_srcdir)/../../../automake/lib.am $(top_srcdir)/../../../automake/local.am
-	cd $(top_srcdir) && $(AUTOMAKE) --foreign src/i386/pc386/Makefile
-
-Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status $(BUILT_SOURCES)
-	cd $(top_builddir) \
-	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
-
-tags: TAGS
-TAGS:
-
-
-distdir = $(top_builddir)/$(PACKAGE)-$(VERSION)/$(subdir)
-
-subdir = src/i386/pc386
-
-distdir: $(DISTFILES)
-	here=`cd $(top_builddir) && pwd`; \
-	top_distdir=`cd $(top_distdir) && pwd`; \
-	distdir=`cd $(distdir) && pwd`; \
-	cd $(top_srcdir) \
-	  && $(AUTOMAKE) --include-deps --build-dir=$$here --srcdir-name=$(top_srcdir) --output-dir=$$top_distdir --foreign src/i386/pc386/Makefile
-	@for file in $(DISTFILES); do \
-	  d=$(srcdir); \
-	  if test -d $$d/$$file; then \
-	    cp -pr $$d/$$file $(distdir)/$$file; \
-	  else \
-	    test -f $(distdir)/$$file \
-	    || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
-	    || cp -p $$d/$$file $(distdir)/$$file || :; \
-	  fi; \
-	done
-info-am:
-info: info-am
-dvi-am:
-dvi: dvi-am
-check-am: all-am
-check: check-am
-installcheck-am:
-installcheck: installcheck-am
-install-exec-am:
-install-exec: install-exec-am
-
-install-data-am:
-install-data: install-data-am
-
-install-am: all-am
-	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
-install: install-am
-uninstall-am:
-uninstall: uninstall-am
-all-am: Makefile
-all-redirect: all-am
-install-strip:
-	$(MAKE) $(AM_MAKEFLAGS) INSTALL_STRIP_FLAG=-s install
-installdirs:
-
-
-mostlyclean-generic:
-
-clean-generic:
-	-test -z "$(CLEANFILES)" || rm -f $(CLEANFILES)
-
-distclean-generic:
-	-rm -f Makefile $(CONFIG_CLEAN_FILES)
-	-rm -f config.cache config.log stamp-h stamp-h[0-9]*
-
-maintainer-clean-generic:
-mostlyclean-am:  mostlyclean-generic
-
-mostlyclean: mostlyclean-am
-
-clean-am:  clean-generic mostlyclean-am
-
-clean: clean-am
-
-distclean-am:  distclean-generic clean-am
-
-distclean: distclean-am
-
-maintainer-clean-am:  maintainer-clean-generic distclean-am
-	@echo "This command is intended for maintainers to use;"
-	@echo "it deletes files that may require special tools to rebuild."
-
-maintainer-clean: maintainer-clean-am
-
-.PHONY: tags distdir info-am info dvi-am dvi check check-am \
-installcheck-am installcheck install-exec-am install-exec \
-install-data-am install-data install-am install uninstall-am uninstall \
-all-redirect all-am all installdirs mostlyclean-generic \
-distclean-generic clean-generic maintainer-clean-generic clean \
-mostlyclean distclean maintainer-clean
-
-
-include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-
-include $(RTEMS_ROOT)/make/leaf.cfg
-
-define make-library
-$(RM) $@
-$(AR) $(ARFLAGS) $@ $^
-$(RANLIB) $@
-endef
-
-$(PROJECT_INCLUDE)/lib:
-	@$(mkinstalldirs) $@
-
-.PRECIOUS: $(LIB)
-
-$(PROJECT_INCLUDE)/rdbg:
-	@$(mkinstalldirs) $@
-
-$(PROJECT_RELEASE)/lib/$(LIBNAME)$(LIBVARIANT).a: $(LIB)
-	$(INSTALL_DATA) $< $@
-
-all: ${ARCH} $(PREINSTALL_FILES) $(TMPINSTALL_FILES)
-
-$(LIB): ${OBJS}
-	$(make-library)
-
-remdeb.h: $(X_FILES)
-	@rm -f $@
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -h -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/$@ remdeb.x )
-
-$(PROJECT_INCLUDE)/rdbg/remdeb.h: remdeb.h
-	$(INSTALL_DATA) $< $@
-
-remdeb_xdr.c: $(X_FILES)
-	@rm -f $@
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -c -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/$@ remdeb.x )
-
-remdeb_svc.c: $(X_FILES)
-	@rm -f $@ tmpSvc.c
-	( pwd=`pwd`; cd $(srcdir)/../..; \
-	$(RPCGEN) -s udp -DFRONTEND=$(FRONTEND) \
-	  -o $$pwd/tmpSvc.c remdeb.x )
-	$(AWK) -f $(srcdir)/../../awk.svc THEPROG="remdeb.h" tmpSvc.c >$@
-	@rm -f tmpSvc.c
-
-debug-am:
-debug: debug-am
-.PHONY: debug debug-am
-
-profile-am:
-profile: profile-am
-.PHONY: profile profile-am
-
-preinstall-am: $(PREINSTALL_FILES)
-preinstall: preinstall-am
-.PHONY: preinstall preinstall-am
-
-depend-am:
-depend: depend-am
-.PHONY: depend depend-am
-
-# Tell versions [3.59,3.63) of GNU make to not export all variables.
-# Otherwise a system limit (for SysV at least) may be exceeded.
-.NOEXPORT: