Index: c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -1,2 +1,12 @@
+2003-12-04	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* console/Makefile.am: Remove all: $(ARCH)..
+	* i2c/Makefile.am: Remove all: $(ARCH)..
+	* nvram/Makefile.am: Remove all: $(ARCH)..
+	* startup/Makefile.am: Remove all: $(ARCH)..
+	* tod/Makefile.am: Remove all: $(ARCH)..
+	* wrapup/Makefile.am: Remove all: $(ARCH).
+	Remove bogus wildcard from CPU_PIECES..
+
 2003-12-03	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/lib/libbsp/m68k/mcf5206elite/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/console/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/console/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -22,5 +22,5 @@
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
 
-all: $(ARCH) $(OBJS) $(PGM)
+all: $(OBJS) $(PGM)
 
 .PRECIOUS: $(PGM)
Index: c/src/lib/libbsp/m68k/mcf5206elite/i2c/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/i2c/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/i2c/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -22,5 +22,5 @@
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
 
-all: $(ARCH) $(OBJS) $(PGM)
+all: $(OBJS) $(PGM)
 
 .PRECIOUS: $(PGM)
Index: c/src/lib/libbsp/m68k/mcf5206elite/nvram/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/nvram/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/nvram/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -22,5 +22,5 @@
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
 
-all: $(ARCH) $(OBJS) $(PGM)
+all: $(OBJS) $(PGM)
 
 .PRECIOUS: $(PGM)
Index: c/src/lib/libbsp/m68k/mcf5206elite/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/startup/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/startup/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -38,5 +38,5 @@
     $(PROJECT_RELEASE)/lib/linkcmds.flash $(PROJECT_RELEASE)/lib/gdbinit
 
-all: $(ARCH) $(OBJS) $(PGM) $(TMPINSTALL_FILES)
+all: $(OBJS) $(PGM) $(TMPINSTALL_FILES)
 
 .PRECIOUS: $(PGM)
Index: c/src/lib/libbsp/m68k/mcf5206elite/tod/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/tod/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/tod/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -24,5 +24,5 @@
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
 
-all: $(ARCH) $(OBJS) $(PGM)
+all: $(OBJS) $(PGM)
 
 .PRECIOUS: $(PGM)
Index: c/src/lib/libbsp/m68k/mcf5206elite/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/wrapup/Makefile.am	(revision 8347069f0b1195b0b352047bb788a7a43cedf266)
+++ c/src/lib/libbsp/m68k/mcf5206elite/wrapup/Makefile.am	(revision 2100ade90375661e9f2d427420cd10f968fd5076)
@@ -11,6 +11,6 @@
     ../$(piece)/$(ARCH)/*.$(OBJEXT))) $(wildcard \
     ../../../../libcpu/$(RTEMS_CPU)/shared/misc/$(ARCH)/*.$(OBJEXT)) \
-    $(foreach piece, $(CPU_PIECES), $(wildcard \
-    ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/$(piece)/$(ARCH)/$(piece).rel)) \
+    $(foreach piece, $(CPU_PIECES), \
+    ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/$(piece)/$(ARCH)/$(piece).rel) \
     $(wildcard \
     ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/fpsp/$(ARCH)/fpsp.rel)
@@ -27,5 +27,5 @@
 	$(make-library)
 
-all: $(ARCH) $(OBJS) $(LIB) $(TMPINSTALL_FILES)
+all: $(OBJS) $(LIB) $(TMPINSTALL_FILES)
 
 include $(top_srcdir)/../../../../automake/local.am